# Changelog

Todas as alterações/correções notáveis dos projetos de integração com o iFood serão disponíveis nesse arquivo.

## [1.1.81] - 01/04/2024

### - Corrigido

- Correção realizado nas rotas de cancelamento. ["db5e1380"](http://gitlab.teknisa.com/odhen/integrations/ifood/-/commit/db5e1380c3d017e00f4edf70869d5298e8c8de1e)

## [1.1.80] - 26/03/2024

### - Adicionado

- Adicionado suporte a múltiplos subsídios de entrega. ["303718f5"](http://gitlab.teknisa.com/odhen/integrations/ifood/-/commit/303718f5d42f126577684a1b3d2fd1f8f6fb261b)

### - Modificado

- Valores de descontos provenientes do iFood com a taxa de entrega como alvo agora são subtraídos da taxa de entrega total em pedidos em que a entrega é processada pelo iFood. ["d2eaa923"](http://gitlab.teknisa.com/odhen/integrations/ifood/-/commit/d2eaa923c4dfd3755c77330f7657a7903fc83f48)

## [1.1.70] - 13/03/2024

### - Modificado

- Adicionado o campo INDEX no processamento de pizzas e retirado a ultima barra na criação das pastas de logs. ["8b07a10f"](http://gitlab.teknisa.com/odhen/integrations/ifood/-/commit/8b07a10f59f11ed46e4bb98f775e95a238eb47d9)

## [1.1.69] - 07/03/2024

### - Removido

- Removido a chave INDEX dentro das observações antes de serem inseridas no banco. ["449bd4ee"](http://gitlab.teknisa.com/odhen/integrations/ifood/-/commit/449bd4eea15207b486c7a35739d20aaccee0ca4a)

## [1.1.68] - 28/02/2024

### - Adicionado

- Acrescentado o endpoint 'dispatch' na condição para definir 'Content-Length 0'. ["b5f5f375"](http://gitlab.teknisa.com/odhen/integrations/ifood/-/commit/b5f5f3750dfa75160cdca05a277e3ad64cd1a100)

## [1.1.67] - 07/02/2024

### - Modificado

- Alterado alguns campos dentro do foreach de pagamentos. ["9957a39a"](http://gitlab.teknisa.com/odhen/integrations/ifood/-/commit/9957a39a940e5fac6e5cbb87585f469b9fe7965d)

## [1.1.66] - 07/02/2024

### - Correção

- Corrigido o tratamento das formas de pagamento para suportar o método OTHER. ["c372d130"](http://gitlab.teknisa.com/odhen/integrations/ifood/-/commit/c372d13063a9c6edae8991863fd8769fd2176e9d)

## [1.1.65] - 02/02/2024

### - Removido

- Retirado o campo 'return 0' do sendMail. ["9b6348fb"](http://gitlab.teknisa.com/odhen/integrations/ifood/-/commit/9b6348fbb84eaeb8992734b4b668aeebeb23d9cf)

## [1.1.64] - 01/02/2024

### - Adicionado

- Incluido tratamento para o campo "target_discount" para descontos em produtos especificos do pedido. ["1ff7e93d"](http://gitlab.teknisa.com/odhen/integrations/ifood/-/commit/1ff7e93d7a743e99cee64f5baf4fc3caa2916f1e)

- Incluido tratamento para o endereço de teste do iFood. ["25e94902"](http://gitlab.teknisa.com/odhen/integrations/ifood/-/commit/25e94902a7f31323ec7df36fd0b82fbab4aca133)

### - Correção

- Corrigido tratamento do calculo no desconto. ["6ab92151"](http://gitlab.teknisa.com/odhen/integrations/ifood/-/commit/6ab92151b63e9ba88279f7192fae3b7ffd61cc38)

## [1.1.63] - 24/11/2023

### - Adicionado

- Inclusão de content-length para evitar o erro 411 nas requests de accept e deny cancellation. ["a41bfb08"](http://gitlab.teknisa.com/odhen/integrations/ifood/-/commit/a41bfb082f4da907a57e0186d3ac33be89dbfc6b)

- Inclusão de UUID do pedido nos logs de cancelamento. ["844c75c3"](http://gitlab.teknisa.com/odhen/integrations/ifood/-/commit/01f38fec91f5319e9154b63196f253d524d9504e)

- Adicionado validação de TelegramChannel. ["4aff1b95"](http://gitlab.teknisa.com/odhen/integrations/ifood/-/commit/4aff1b957c0c1add2a5fe4349b7cb0e14c645c39)

### - Correção

- Correção em condicional para verificar pedidos que deram erro. ["d02ee637"](http://gitlab.teknisa.com/odhen/integrations/ifood/-/commit/d02ee6378db3eae692dc7acaf7d5868b6577c48b)

### - Modificado

- Atualização na rotina para não mover para processado pedidos com timeout na rota de /start. Remoção dos pedidos de pending após 10 minutos. Aumento do timeout de conexão da rota /start. ["4b5ae753"](http://gitlab.teknisa.com/odhen/integrations/ifood/-/commit/4b5ae753d647a0bf97faa6f786a36772a78476d8)

- Atualização na rotina de arquivos expirados para remover os mesmos no final da análise e registrar em log. ["9b981fd8"](http://gitlab.teknisa.com/odhen/integrations/ifood/-/commit/9b981fd83b685c5a6518376f0362cef36dc60286)

## [1.1.60] - 16/08/2023

### - Adicionado

- Inclusão de content-length para evitar o erro 411 nas requests de accept e deny cancellation. ["a41bfb08"](http://gitlab.teknisa.com/odhen/integrations/ifood/-/commit/a41bfb082f4da907a57e0186d3ac33be89dbfc6b)

- Inclusão de UUID do pedido nos logs de cancelamento. ["844c75c3"](http://gitlab.teknisa.com/odhen/integrations/ifood/-/commit/01f38fec91f5319e9154b63196f253d524d9504e)

- Adicionado validação de TelegramChannel. ["4aff1b95"](http://gitlab.teknisa.com/odhen/integrations/ifood/-/commit/4aff1b957c0c1add2a5fe4349b7cb0e14c645c39)

### - Correção

- Correção em condicional para verificar pedidos que deram erro. ["d02ee637"](http://gitlab.teknisa.com/odhen/integrations/ifood/-/commit/d02ee6378db3eae692dc7acaf7d5868b6577c48b)

### - Modificado

- Atualização na rotina para não mover para processado pedidos com timeout na rota de /start. Remoção dos pedidos de pending após 10 minutos. Aumento do timeout de conexão da rota /start. ["4b5ae753"](http://gitlab.teknisa.com/odhen/integrations/ifood/-/commit/4b5ae753d647a0bf97faa6f786a36772a78476d8)

- Atualização na rotina de arquivos expirados para remover os mesmos no final da análise e registrar em log. ["9b981fd8"](http://gitlab.teknisa.com/odhen/integrations/ifood/-/commit/9b981fd83b685c5a6518376f0362cef36dc60286)

## [1.1.59] - 08/08/2023

### - Adicionado

- Implementação de rotina para retry em caso de timeout na rota de confirmacao de pedido e executar a mesma em modo 'verbose' para maior detalhamento. Criação de tipo 'networkVerbose'. ["8a4d4d51"](http://gitlab.teknisa.com/odhen/integrations/ifood/-/commit/8a4d4d51898cd1faf7d6054dbd318289012e3ef4)

- Adicionado função para enviar mensagens de erro para o Telegram. ["01f38fec"](http://gitlab.teknisa.com/odhen/integrations/ifood/-/commit/01f38fec91f5319e9154b63196f253d524d9504e)

- Adicionado validação de TelegramChannel. ["4aff1b95"](http://gitlab.teknisa.com/odhen/integrations/ifood/-/commit/4aff1b957c0c1add2a5fe4349b7cb0e14c645c39)

### - Correção

- Correções na rotina de confirmação do pedido na forma como é obtida a taxa do ifood, melhorias na rotina de logs de erro em rede. ["0111ea85"](http://gitlab.teknisa.com/odhen/integrations/ifood/-/commit/0111ea85cdff6c91e4e1d61b2499f34c19bd99af)

## [1.1.58] - 26/04/2023

### - Correção

- Correção realizada na validação de pedido agendado. ["28e58f77"](http://gitlab.teknisa.com/odhen/integrations/ifood/-/commit/28e58f77b141830a4e84a28eb49a0a522564221f)

### - Modificado

- Alterado o tratamento de descontos para considerar produtos com mais de uma quantidade. ["1dc8004c"](http://gitlab.teknisa.com/odhen/integrations/ifood/-/commit/1dc8004c60d200b9ffb361a90644e78f1d0ac2e7)

### - Adicionado

- Adicionado função para enviar mensagens de erro para o Telegram. ["01f38fec"](http://gitlab.teknisa.com/odhen/integrations/ifood/-/commit/01f38fec91f5319e9154b63196f253d524d9504e)

## [1.1.57] - 04/01/2023

### - Correção

- A integração passa a considerar o "sponsorshipValue[_name_]" EXTERNAL no desconto da taxa de entrega. ["d6b4e3be"](http://gitlab.teknisa.com/odhen/integrations/ifood/-/commit/d6b4e3befb78aa7226e397869b69a108135e5d7b)

- Corrigido o desconto para taxa de entrega alteracao do campo code para method dentro de payments[methods]. ["99cf3e91"](http://gitlab.teknisa.com/odhen/integrations/ifood/-/commit/99cf3e91ef9791e61e3717989052efb91da053fe)

- Corrigido uma situação em que o produto simples não considerava a quantidade real. ["10e64d7a"](http://gitlab.teknisa.com/odhen/integrations/ifood/-/commit/10e64d7aea2f4095d2994b804b88a9420d459f3d)

## [1.1.56] - 19/12/2022

### - Correção

- Corrigido logo enviada nos e-mails. ["5ba30732"](http://gitlab.teknisa.com/odhen/integrations/ifood/-/commit/5ba30732a55c275c9ed446426167f4d23d80d9e1)

### - Modificado

- Alterado o nome Teknisa Varejo para Teknisa Retail. Alterado o campo DSOBSPEDDIGCMD para receber TXPRODCOMVEN. ["e09caf57"](http://gitlab.teknisa.com/odhen/integrations/ifood/-/commit/e09caf57befdf460e5385c6d22078b25d449b80d)

## [1.1.55] - 11/11/2022

### - Correção

- Correção no Notice quando o method vem no metodo de pagamento. ["3717d0b0"](http://gitlab.teknisa.com/odhen/integrations/ifood/-/commit/3717d0b017c3b58aee5081dab0bd374c52a98c24)

- ### - Adicionado

- Implementado validação do motivo do cancelamento dos pedidos. ["0081b1bb"](http://gitlab.teknisa.com/odhen/integrations/ifood/-/commit/0081b1bbb468e76405c332bf244b7355fb586a85)

- Implementato rtatamento para descontos do tipo EXTERNAL e tratamento de desconto External para descontos em um único item. ["dd97fdcc"](http://gitlab.teknisa.com/odhen/integrations/ifood/-/commit/dd97fdcc5bfadb8c6c443e609c1cbb134d6d4b96)

## [1.1.54] - 29/10/2022

### - Correção

- Corrigido tradução de observações escritas para exibição no KDS. ["38f2cda6"](http://gitlab.teknisa.com/odhen/integrations/ifood/-/commit/38f2cda6237051d1465233bbfa2d64da090d540a)

## [1.1.53] - 06/10/2022

### - Adicionado

- Compatibilidade com o módulo Entrega Facil iFood. ["97bade1b"](http://gitlab.teknisa.com/odhen/integrations/ifood/-/commit/97bade1b11124ca135d835148248d42d7e9a2784)

## [1.1.52] - 17/08/2022

### - Modificado

- Mudanças no mecanismo de polling da integração para suporte a 500+ restaurantes por aplicativo iFood e aprimoramento dos logs de rede (módulo webhook). ["6dd4ab16"](http://gitlab.teknisa.com/odhen/integrations/ifood/-/commit/6dd4ab16361c6bfc20181afbca0f4e4c208f9913)

## [1.1.51] - 23/05/2022

### - Correção

- Corrigido PK_OBSITCOMANDAVEN que estava duplicando observações. ["e227d521"](http://gitlab.teknisa.com/odhen/integrations/ifood/-/commit/e227d521089e0645360888e5d57a278d50dd0917#dacb45819890f4c6339889c6d6ea5308573be572)

## [1.1.50] - 16/02/2022

### - Modificado

- Mudança no  numero máximo de itens em paralelo que a integração processa (de 20 para 120) ["eb4a7c59"](http://gitlab.teknisa.com/odhen/integrations/ifood/-/commit/eb4a7c590076f29f372869f771e608c46de55d01)
- Removido log debug gerado de forma desnecessária em produção
["e430f2ba"](http://gitlab.teknisa.com/odhen/integrations/ifood/-/commit/e430f2ba34cde41c3d0e8045fcfe98c7167b0be4)

## [1.1.50] - 15/02/2022

### - Correção

- Correção de integração incorretas de pedidos onde o sistema inseria o preço do produto combinado com preço cheio ao invés do preço unitário ["b4bc9b2c"](http://gitlab.teknisa.com/odhen/integrations/ifood/-/commit/b4bc9b2cb7955563d580a923ce783ceea4df1c1a)

## [1.1.49] - 10/02/2022

### - Correção

- Alterado o insert para a 'ITCOMANDAVEN' adicionando o campo com o nome do consumidor 'NMCONSVEND' ["b4bc9b2c"](http://gitlab.teknisa.com/odhen/integrations/ifood/-/commit/b4bc9b2cb7955563d580a923ce783ceea4df1c1a)

## [1.1.48] - 27/01/2022

### - Correção

- Alterado o campo $merchantDeliveryFeeDiscount no projeto onde o mesmo estava com somente um '=' ["49387676"](http://gitlab.teknisa.com/odhen/integrations/ifood/-/commit/49387676338c6143549929bab11dcb286eedfdd4)

## [1.1.48] - 05/01/2022

### - Correção

- Correção realizada para evitar a exibição de erro quando a variável "$result" está vazia. ["da2fba07"](http://gitlab.teknisa.com/odhen/integrations/ifood/-/commit/da2fba073cb39a708995e2c92223682ff9dc0857)

## [1.1.48] - 04/01/2022

### - Modificado

- Alterado no projeto o formato do caminho de geração de logs para que possa dar deploy no SAAS. ["16243ae0"](http://gitlab.teknisa.com/odhen/integrations/ifood/-/commit/16243ae02532aff8468f2dad1a745db917a14aba)
